import Foundation
import CoreLocation
import snowm_scanner
import FirebaseDatabase

class BackgroundScannerResponse: SnowMBackgroundScanningServiceDelegate {

    static let shared = BackgroundScannerResponse()
    
    let notification = NotificationHelper()
    
    var database = Database.database()
    var count = 0

    func onLocationUpdated(locations: [CLLocation]) {
        sendLogToServer(message:"locationChangeDetected");
    }
    
    func onBeaconDetected(beacons: [SnowMBeacon], customData: Dictionary<String, Any>?) {
        sendLogToServer(message:"Scanned beacons")
    }
    
    
    func onRegionEntered(){
        count+=1
        notification.showNotification(message: "onRegionEntered \(count)");
        sendLogToServer(message:"onRegionEntered")
    }
    
    func onRegionExited(){
        count+=1
        sendLogToServer(message:"onRegionExited")
        notification.showNotification(message: "onRegionExited \(count)");
    }
    
    var lastMessage = "";
    func sendLogToServer(message: String){
        if(lastMessage == message) {return}
        lastMessage = message
        var data  = Dictionary<String, Any>()
        data["message"] = message
        let dateFormatterGet = DateFormatter()
           dateFormatterGet.dateFormat="yyyy-MM-dd hh:mm:ss"
           data["time"]   = dateFormatterGet.string(from: Date())
        database.reference().child("logs").childByAutoId().setValue(data);
    }
    
    
    func didEnterGeofence() {
        count+=1
        sendLogToServer(message:"didEnterGeofence")
        notification.showNotification(message: "didEnterGeofence \(count)");
    }
    
    func didExitGeofence() {
        count+=1
        sendLogToServer(message:"didExitGeofence")
        notification.showNotification(message: "didEnterGeofence \(count)");
    }
    
}
